Composite <- function(var, occurrences, lag) {
  #
  # This function composites the 3-d field (x, y, time) according the indices
  # of occurrences (nclusters, time) and compute the pvalue of the anomalies
  # obtained.
  # 
  # Args
  #  var : 3-dimensional matrice (x, y, time) containing the variable to 
  #        composite
  #  occurrences : 1-dimension array (ncluster) containing 1 or 2 or .. when
  #                a spacific cluster occurs at specific time step
  #  lag :
  #
  # Return :
  #   composites : 2-dimensional matrice (x, y) containing the composites  
  #   pvalue   : 2-dimensional matrice (x, y) containing the pvalue of the 
  #              composite anomalies obtained through a t-test
  #              that accounts for the serial dependence of the data
  #
  # History:
  #   
##############################################################################

# HEre there should be simply a call to Mean1Dim on var[,,occurrences]
#  and then a loop on the spatial dimensions to call Eno to get the number
# of independent data and then a call to t.test to get the pvalue
# Then you send the composites and pvalue as a list

# 22/07 : The documentation is not correct above. As you have coded it, the
# 22/07 : dimensions of occurrences is (time) and not (nclusters). 
# 22/07 : spacific -> specific
# 22/07 : Also as you have coded it, the outputs will have dimensions 
# 22/07 : (x, y, nclusters)
# 22/07 : Please corret the documentation accordingly

noc=max(occurrences)
nalani=array(dim=c(noc,length(var[,1,1]),length(var[1,,1])))
# 22/07 : This line can be simplified as 
# 22/07 : nalani <- array(dim = c(noc, dim(var)[1:2]))
# 22/07 : to obtain an output composite with dimensions (nclusters, x, y)
# 22/07 : or nalani <- array(dim = c(dim(var)[1:2], noc))
# 22/07 : to obtain (x, y, nclusters)
# 22/07 : The second option makes more sense if your input has dimensions
# 22/07 : (x, y, time)
# 22/07 : You need to define at the same time
# 22/07 : pvalue <- array(dim = c(dim(var)[1:2], noc))

for (ii in 1:noc) {
    # 22/07 : The lines below can be greatly simplified by using 
    # 22/07 : the built-in R function which
    # 22/07 : indices <- which(occurrences==ii)
    # 22/07 : provides you with the locations of the elements to composite
    # 22/07 : along the time dimension in var for cluster ii
    # 22/07 : nalani[ii,,] <- mean(var[,indices])
    # 22/07 : provides you with the same result as what do the next 10 lines
    # 22/07 : in case of lag = 0
    counter=0
    tmp_matrix=matrix(0,length(var[,1,1]),length(var[1,,1]))
    for (jj in 1:length(occurrences)) {
        if (occurrences[jj]==ii+lag) {
        # 22/07 : Here, I can see that you have tested only with lag = 0
        # 22/07 : Example : occurrences = c(1,3,2,3,1,2)
        # 22/07 : If lag = 5 , and ii = 2, you are testing whether:
        # 22/07 :                          1  = (2+5)
        # 22/07 :                          3  = (2+5)
        # 22/07 :                          2  = (2+5)
        # 22/07 :                          3  = (2+5)
        # 22/07 :                          1  = (2+5)
        # 22/07 :                          2  = (2+5)
        # 22/07 : which will never be true
           counter=counter+1
           tmp_matrix=tmp_matrix+var[,,jj]
        }
    }
    tmp_matrix=tmp_matrix/counter
    nalani[ii,,]=tmp_matrix
    # 22/07 : So the previous 10 lines can be replaced by:
    # 22/07 : indices <- which(occurrences==ii)
    # 22/07 : nalani[ii,,] <- mean(var[,indices])
    # 22/07 : for the same result
    # 22/07 : To account for the lag,
    # 22/07 : indices <- which(occurrences==ii) should be replaced by
    # 22/07 : indices <- which(occurrences==ii)+lag
    # 22/07 : to shift the locations along time of the data to composite plus
    # 22/07 : toberemoved=which(0>indices|indices>dim(var)[3])
    # 22/07 : to detect any indice that would fall outside of [0;time] plus
    # 22/07 : if { length(toberemoved) > 0 } ( indices=indices[-toberemoved] }
    # 22/07 : to effectively remove these indices outside of [0;time]
    # 22/07 : Finally, you need to account for the potential missing values
    # 22/07 : in the input var ( which you had not done in your initial 10 
    # 22/07 : lines above)
    # 22/07 : nalani[ii,,] <- mean(var[,indices])
    # 22/07 : should be replaced by nalani[ii,,] <- mean(var[,indices],na.rm=T)
    # 22/07 : In this same loop, you can compute the number of equivalent data
    # 22/07 : in N1 <- Eno(var,3) for var and N2 <- Eno(var[,indices],3)
    # 22/07 : and then apply the t-test formula for var and var[,indices] using
    # 22/07 : N1 and N2 as number of degrees of freedom
}

 Composite <- array(dim=c(noc,length(var[,1,1]),length(var[1,,1])))
 Composite[] <- nalani
 # 22/07: The same comment as the one I did for the SeaIceMode function apply
 # 22/07: here. The lines above are useless in your case. In the other 
 # 22/07: functions, you have taken example from, they were performing a
 # 22/07: reshape. You do not need any reshape here.
 # 22/07: But you need to define a list
 # 22/07: invisible(list(Composite = nalani, Pvalue = pvalue))
 # 22/07: and remove the line below
 # output
 Composite
}




